package  
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author Time
	 */
	public class BeamBase extends Entity
	{
		[Embed(source = "data/BeamBase.png")] private var imgBeamBase:Class;
		private var sprBeamBase:Image = new Image(imgBeamBase);
		
		private var myBeam:BitmapData;
		
		public static const myScale:int = Game.scale;
		public static const myLayer:int = -50;
		
		private var yTo:int = 0;
		
		private const colorMultMax:Number = 0.75;
		private const colorMultMin:int = 0;
		private var colorMultRate:Number = 0.04;
		private var colorMult:Number = colorMultMin;
		
		private var positionMatrix:Matrix;
		
		public var tLight:Array = new Array();
		
		public function BeamBase(_x:int, _y:int) 
		{
			super(_x, _y, sprBeamBase);
			yTo = _y;
			
			sprBeamBase.centerOO();
			sprBeamBase.scale = myScale;
		}
		
		override public function removed():void
		{
			if (myBeam)
			{
				myBeam.dispose();
			}
		}
		
		override public function added():void
		{
			positionMatrix = new Matrix();
			yTo = y;
			while (!FP.world.collideLine("Solid", x, y, x, yTo - myScale) && yTo > 0 && yTo <= FP.height)
			{
				yTo -= Lighting.grid;
				tLight[0]=new Light(x, yTo, 4, 0xFF0000, false, false);
				tLight[1] = new Light(x + Lighting.grid, yTo, 4, 0xFF0000, false, false);
				FP.world.add(tLight[0]);
				FP.world.add(tLight[1]);
				FP.world.remove(tLight[0]);
				FP.world.remove(tLight[1]);
			}
			if (myBeam)
			{
				myBeam.dispose();
			}
			myBeam = new BitmapData(Lighting.grid, Math.abs(y - yTo), false);
			myBeam.fillRect(myBeam.rect, 0xFFFF0000);
			positionMatrix.translate(x, yTo);
		}
		
		override public function update():void
		{
			colorMult += colorMultRate;
			if (colorMult >= colorMultMax)
			{
				colorMult = colorMultMax;
				colorMultRate = -colorMultRate;
			}
			if (colorMult <= colorMultMin)
			{
				colorMult = colorMultMin;
				colorMultRate = -colorMultRate;
			}
		}
		
		override public function render():void
		{
			FP.buffer.draw(myBeam, positionMatrix, new ColorTransform(1, colorMult, colorMult, 0.5 + colorMult/colorMultMax * 0.3));
			sprBeamBase.scaleY = -sprBeamBase.scaleY;
			sprBeamBase.render(new Point(x, yTo + myScale), FP.camera);
			sprBeamBase.scaleY = -sprBeamBase.scaleY;
			super.render();
		}
		
	}

}