package  
{
	import flash.display.BitmapData;
	import flash.geom.Matrix;
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Time
	 */
	public class Explosion extends Entity
	{
		private var explosion:BitmapData;
		
		private var currentRadius:Number = 0;
		private var maxRadius:int;
		private var color:uint;
		
		private var targets:Object;
		
		private var myLight:Light;
		
		public function Explosion(_x:int, _y:int, _r:int, _targets:Object, _c:uint=0xFFFFFF) 
		{
			super(_x, _y);
			maxRadius = _r;
			explosion = new BitmapData(maxRadius * 2, maxRadius * 2, true, 0x00000000);			
			color = _c;
			myLight = new Light(x, y, maxRadius + 6, color, true, false);
			FP.world.add(myLight);
			
			targets = _targets;
			
			var size:int = (maxRadius * Game.scale + Math.sqrt(Math.pow(maxRadius * Game.scale, 2) / 2));
			setHitbox(size, size, size/2, size/2);
			type = "Explosion";
		}
		
		override public function added():void
		{
			var e:Entity;
			var v:Vector.<Entity> = new Vector.<Entity>();
			collideTypesInto(targets, x, y, v)
			for each (e in v)
			{
				switch(e.type)
				{
					case "Charger":
						(e as Charger).getHurt();
						break;
					case "Bat":
						(e as Bat).getHurt();
						break;
					case "Eye":
						(e as Eye).getHurt();
						break;
					default:
				}
			}
		}
		
		override public function removed():void
		{
			if (explosion)
			{
				explosion.dispose();
			}
			if (myLight)
			{
				FP.world.remove(myLight);
			}
		}
		
		override public function update():void
		{
			currentRadius+=0.5;
			if (currentRadius > maxRadius)
			{
				FP.world.remove(this);
			}
			if (explosion)
			{
				clearBitmap();
				Draw.setTarget(explosion);
				Draw.circlePlus(maxRadius, maxRadius, currentRadius, color,1, false);
				Draw.resetTarget();
			}
			
			if (myLight)
			{
				myLight.x = x;
				myLight.y = y;
			}
		}
		
		override public function render():void
		{
			super.render();
			var m:Matrix = new Matrix();
			m.scale(Game.scale, Game.scale);
			m.translate(x - maxRadius * Game.scale - FP.camera.x, y - maxRadius * Game.scale - FP.camera.y);
			FP.buffer.draw(explosion, m);
		}
		
		private function clearBitmap():void
		{
			explosion.fillRect(explosion.rect, 0x00000000);
		}
		
	}

}