package 
{
	import flash.geom.Rectangle;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.World;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import flash.geom.Point;
	import net.flashpunk.utils.Draw;
	import editor.Editor;
	import editor.EditorFunctions;
	/**
	 * ...
	 * @author Time
	 */
	public class Game extends World
	{		
		[Embed(source = "data/back.png")] private var imgBack:Class;
		
		public static var solid:SolidAll;
		
		public static const blockColor:Array = new Array(FP.getColorARGB(255, 152, 122, 175), FP.getColorARGB(255, 91, 118, 52), FP.getColorARGB(255, 133, 75, 37));// 0xFFFFCC44;
		public static const blockColorBack:Array = new Array(FP.getColorARGB(255, 79, 56, 95), FP.getColorARGB(255, 46, 60, 26), FP.getColorARGB(255, 67, 37, 18));// 0xFFFFCC44;
		public static const scale:int = Lighting.grid;
		
		private static var currentLevel:XML;
		
		public static var shake:int = 0;
		
		public function Game(cl:XML = null) 
		{
			FP.console.enable();
			super();
			currentLevel = cl;
		}
		override public function begin():void
		{
			super.begin();
			addGraphic(new Backdrop(imgBack), 1000);
			add(new Lighting());
			
			if (currentLevel)
			{
				EditorFunctions.readXML(currentLevel);
			}
			Lighting.updateStaticLights();
			
			add(solid = new SolidAll());
		}
		override public function update():void
		{
			super.update();
			
			var player:Player = nearestToPoint("Player", FP.camera.x + FP.width / 2, FP.camera.y + FP.height / 2) as Player;
			
			FP.camera.x = 0;
			FP.camera.y = 0;
			//FP.camera.x += ((player.x - FP.width / 2) - FP.camera.x) / 5;
			//FP.camera.y += ((player.y - FP.height / 2) - FP.camera.y) / 5;
			if (shake > 0)
			{
				shake--;
				FP.camera.x += Math.random() * shake - shake / 2;
				FP.camera.y += Math.random() * shake - shake / 2;
			}
			//FP.camera = new Point(Math.round(FP.camera.x), Math.round(FP.camera.y));
			
			if (Input.released(Editor.startKey))
			{
				FP.world = new Editor(currentLevel);
			}
		}
		override public function render():void
		{
			super.render();
		}
		
	}

}