package  
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author Time
	 */
	public class LightBall extends Entity
	{
		[Embed(source = "data/LightBall.png")] private var imgLightBall:Class;
		private var sprLightBall:Image = new Image(imgLightBall);
		
		private const accel:Point = new Point(0.2, 0.2);
		private const friction:Number = 0.0125;
		private const maxSpeed:Point = new Point(3, 8);
		private const col1:uint = 0xFFFFFF;
		private const col2:uint = 0x00FF00;
		
		private var colLerp:Number = 0;
		private var colLerpRate:Number = 0.025;
		
		private var life:int = 20;
		
		private var speed:Point = new Point();
		
		private var spinDir:int = 1;
		
		private var myLight:Light;
		
		public function LightBall(_x:int, _y:int, _s:Point) 
		{
			super(_x, _y, sprLightBall);
			speed = _s;
			
			sprLightBall.scale = Game.scale / sprLightBall.width;
			sprLightBall.centerOO();
			sprLightBall.centerOrigin();
			
			setHitbox(Game.scale * 3 /4, Game.scale * 3 /4, Game.scale * 3 / 8, Game.scale * 3 /8);
			type = "LightBall";
			
			myLight = new Light(x, y, 12, 0xFFFFFF, true, false);
			FP.world.add(myLight);
		}
		
		override public function update():void
		{
			if (life > 0)
			{
				if (Math.floor(Math.random() * life/2))
				{
					myLight.on = false;
				}
				else
				{
					myLight.on = true;
				}
				life--;
			}
			else
			{
				myLight.on = true;
				var p:Player = collide("Player", x, y) as Player;
				if (p)
				{
					FP.world.remove(this);
				}
			}
			movementValues();
			move();
			
			sprLightBall.angle -= speed.x * 5;
			
			if (speed.x != 0)
			{
				spinDir = FP.sign(speed.x);
			}
			
			if (speed.x == 0 && speed.y == 0)
			{
				while (sprLightBall.angle < 0)
				{
					sprLightBall.angle += 360;
				}
				while (sprLightBall.angle >= 360)
				{
					sprLightBall.angle -= 360;
				}
				sprLightBall.angle -= 180 / Math.PI * FP.angle_difference(0, -sprLightBall.angle / 180 * Math.PI) / 10;
				//sprLightBall.angle -= 10 * spinDir;
			}
			
			if (myLight)
			{
				colLerp += colLerpRate;
				if (colLerp >= 1)
				{
					colLerp = 1;
					colLerpRate = -colLerpRate;
				}
				if (colLerp <= 0)
				{
					colLerp = 0;
					colLerpRate = -colLerpRate;
				}
				myLight.color = FP.colorLerp(col1, col2, colLerp);
				sprLightBall.color = myLight.color;
				myLight.x = x;
				myLight.y = y;
			}
		}
		
		override public function removed():void
		{
			if (myLight)
			{
				FP.world.remove(myLight);
			}
			var p:Player = collide("Player", x, y) as Player;
			if (p)
			{
				p.clearLight(this);
			}
			//FP.world.add(new Explosion(x, y, 5, ["Charger", "Bat", "Eye"], 0xFF0000));
		}
		
		private function movementValues():void
		{
			var sign:int = FP.sign(speed.x);
			speed.x -= sign * friction;
			if (FP.sign(speed.x) != sign)
			{
				speed.x = 0;
			}
			
			speed.y += accel.y;
			if (speed.y > maxSpeed.y)
			{
				speed.y = maxSpeed.y;
			}
		}
		
		private function move():void
		{
			var i:int;
			for (i = 0; i < Math.abs(speed.x); i++)
			{
				if (!collide("Solid", x + FP.sign(speed.x), y))
				{
					x += FP.sign(speed.x) * Math.min(Math.abs(speed.x) - i, 1);
				}
				else
				{
					speed.x = -speed.x / 2;
					break;
				}
			}
			for (i = 0; i < Math.abs(speed.y); i++)
			{
				if (!collide("Solid", x, y + FP.sign(speed.y)))
				{
					y += FP.sign(speed.y) * Math.min(Math.abs(speed.y) - i, 1);
				}
				else
				{
					speed.x *= 3 / 4;
					speed.y = -speed.y / 2;
					if (Math.abs(speed.y) <= 0.2)
					{
						speed.y = 0;
					}
					break;
				}
			}
		}
		
	}

}