package  editor
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import flash.utils.getDefinitionByName;
	import net.flashpunk.graphics.Spritemap;
	import editor.Editor;
	/**
	 * ...
	 * @author Time
	 */
	public class EditorFunctions 
	{
		/*
		 * Have to add these variables so the classes are compiled for getDefinitionByName
		 * It didn't work just to import them.
		 */
		private var dummySolid:Solid;
		private var dummySolidBack:SolidBack;
		private var dummyPlayer:Player;
		private var dummyCharger:Charger;
		private var dummyBat:Bat;
		private var dummyStalactite:Stalactite;
		private var dummyEyeWeed:EyeWeed;
		private var dummyBeamBase:BeamBase;
		
		public function EditorFunctions() 
		{
			
		}
		
		public static function makeXML():XML
		{
			var e:Entity;
			var n:XML;
			var v:Vector.<Entity> = new Vector.<Entity>();
			FP.world.getAll(v);
			
			var cl:XML =<Level>
							<Objects>
							</Objects>
						</Level>;
						
			for (var j:int = 0; j < Editor.icons.length; j++)
			{
				cl = checkNormal(cl, j, v);
			}
			FP.console.log(cl.toString());
			return cl;
		}
		
		public static function checkNormal(cl:XML, i:int, v:Vector.<Entity>):XML
		{
			var e:Entity;
			for each (e in v)
			{
				if (e.type != Editor.icons[i])
				{
					continue;
				}
				var n:XML = <{Editor.icons[i]} x={e.x} y={e.y} v1={(e as Item).v1} v2={(e as Item).v2} v3={(e as Item).v3}/>;
				cl.Objects.appendChild(n);
			}
			return cl;
		}
		
		/*
		 * Functions to load in the editor's entities from an XML file
		 */
		
		public static function readEditorXML(cl:XML):void
		{
			var e:Entity;
			var v:Vector.<Entity> = new Vector.<Entity>();
			FP.world.getClass(Item, v);
			for each(e in v)
			{
				FP.world.remove(e);
			}
			for (var j:int = 0; j < Editor.icons.length; j++)
			{
				switch(Editor.icons[j])
				{
					case "Solid":
						createEditorThreeValues(cl, j);
						break;
					case "SolidBack":
						createEditorThreeValues(cl, j);
						break;
					case "Stalactite":
						createEditorOneValue(cl, j);
						break;
					default:
						createEditorNormal(cl, j);
				}
			}
		}
		
		public static function createEditorNormal(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				FP.world.add(new Item(item.@x, item.@y, i));
			}
		}
		
		public static function createEditorOneValue(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				FP.world.add(new Item(item.@x, item.@y, i, item.@v1));
			}
		}
		
		public static function createEditorTwoValues(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				FP.world.add(new Item(item.@x, item.@y, i, item.@v1, item.@v2));
			}
		}
		
		public static function createEditorThreeValues(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				FP.world.add(new Item(item.@x, item.@y, i, item.@v1, item.@v2, item.@v3));
			}
		}
		
		/*
		 * Creation functions for in-game level building.
		 */
		
		public static function readXML(cl:XML):void
		{
			for (var j:int = 0; j < Editor.icons.length; j++)
			{
				switch(Editor.icons[j])
				{
					case "Solid":
						createThreeValues(cl, j);
						break;
					case "SolidBack":
						createThreeValues(cl, j);
						break;
					case "Stalactite":
						createOneValue(cl, j);
						break;
					default:
						createNormal(cl, j);
				}
			}
		}
		
		public static function createNormal(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				var c:Class = getDefinitionByName(Editor.icons[i]) as Class;
				FP.world.add(new c(int(item.@x), int(item.@y)));
			}
		}
		
		public static function createOneValue(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				var c:Class = getDefinitionByName(Editor.icons[i]) as Class;
				FP.world.add(new c(int(item.@x), int(item.@y), int(item.@v1)));
			}
		}
		
		public static function createTwoValues(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				var c:Class = getDefinitionByName(Editor.icons[i]) as Class;
				FP.world.add(new c(int(item.@x), int(item.@y), int(item.@v1), int(item.@v2)));
			}
		}
		
		public static function createThreeValues(cl:XML, i:int):void
		{
			var item:XML;
			for each(item in cl.Objects.child(Editor.icons[i]))
			{
				var c:Class = getDefinitionByName(Editor.icons[i]) as Class;
				FP.world.add(new c(int(item.@x), int(item.@y), int(item.@v1), int(item.@v2), int(item.@v3)));
			}
		}
		
	}

}