package editor 
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Time
	 */
	public class Item extends Entity
	{
		private var _xoff:int = 0;
		private var _yoff:int = 0;
		public var _width:int = 0;
		public var _height:int = 0;
		public var v1:int;
		public var v2:int;
		public var v3:int;
		private var _type:int;
		
		//For the BeamBase, this is used for displaying the beam.
		private var yTo:int;
		
		public function Item(_x:int, _y:int, _t:int, _v1:int = 0, _v2:int = 0, _v3:int = 0) 
		{
			super(_x, _y);
			yTo = y;
			_type = _t;
			type = Editor.icons[_type];
			layer = Editor.layers[_type];
			Editor.addedItem = true;
			v1 = _v1;
			v2 = _v2;
			v3 = _v3;
			switch(type)
			{
				case "Solid":
					_width = _v1;
					_height = _v2;
					setHitbox(_width, _height);
					break;
				case "SolidBack":
					_width = _v1;
					_height = _v2;
					setHitbox(_width, _height);
					break;
				case "Stalactite":
					makeGraphic();
					(graphic as Spritemap).frame = _v1;
					break;
				case "EyeWeed":
					makeGraphic();
					(graphic as Spritemap).frame = 1;
					break;
				case "BeamBase":
					makeGraphic();
					beamBaseReset();
					break;
				default:
					makeGraphic();
			}
		}
		
		override public function update():void
		{
			if (type == "BeamBase" && Editor.addedItem && FP.world.collideLine("Solid", x, y, x, yTo - Editor.scales[_type]))
			{
				beamBaseReset();
			}
		}
		
		public function makeGraphic():void
		{
			var tSpr:Image;
			graphic = new Spritemap(Editor.images[_type], Editor.sprites[_type].width, Editor.sprites[_type].height);
			tSpr = (graphic as Image);
			tSpr.scale = Editor.scales[_type];
			tSpr.centerOO();
			tSpr.x = Math.floor(tSpr.x * tSpr.scale / Editor.scales[_type]) * Editor.scales[_type] / tSpr.scale;
			_xoff = tSpr.x * tSpr.scale;
			_yoff = tSpr.y * tSpr.scale;
			_width = tSpr.width * tSpr.scale;
			_height = tSpr.height * tSpr.scale;
		}
		
		override public function render():void
		{
			if (type == "Solid")
			{
				Draw.rect(x + _xoff, y + _yoff, _width, _height, Game.blockColor[v3], 1);
			}
			else if (type == "SolidBack")
			{
				Draw.rect(x + _xoff, y + _yoff, _width, _height, Game.blockColorBack[v3], 1);
			}
			else if (type == "BeamBase")
			{
				Draw.rect(x, yTo, Editor.scales[_type], y - yTo, 0xFF0000, 0.8);
				(graphic as Image).scaleY = -(graphic as Image).scaleY;
				(graphic as Image).render(new Point(x, yTo + Editor.scales[_type]), FP.camera);
				(graphic as Image).scaleY = -(graphic as Image).scaleY;
				graphic.render(new Point(x, y), FP.camera)
			}
			else if(graphic)
			{
				graphic.render(new Point(x, y), FP.camera);
			}
			
			if (Input.mouseX >= x + _xoff && Input.mouseY >= y + _yoff && Input.mouseX < x + _xoff + _width && Input.mouseY < y + _yoff + _height)
			{
				if (Editor.mouseReleased && Input.check(Editor.deleteKey))
				{
					FP.world.remove(this);
				}
				Draw.rect(x + _xoff, y + _yoff, _width, _height, 0xFFFF00, 0.4);
			}
		}
		
		public function beamBaseReset():void
		{
			switch(type)
			{
				case "BeamBase":
					yTo = y;
					while (!FP.world.collideLine("Solid", x, y, x, yTo - Editor.scales[_type]) && yTo > 0 && yTo <= FP.height)
					{
						yTo -= Lighting.grid;
					}
					break;
				default:
			}
		}
		
	}

}